SystemOrganization addCategory: #Perspectives!
SystemOrganization addCategory: #'Perspectives-Tests'!
SystemOrganization addCategory: #'Perspectives-Visualization'!

Morph subclass: #PInstanceMorph
	instanceVariableNames: 'pobject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives-Visualization'!

!PInstanceMorph class methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 17:40'!
for: aPObject
	^ self new
		instance: aPObject;
		yourself! !

!PInstanceMorph methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 17:59'!
adjust
	| t |
	t := TextMorph new contents: pobject asString.
	self extent: t width@200.
	self addMorph: t! !

!PInstanceMorph methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 17:58'!
initialize
	super initialize.
	self color: Color blue.! !

!PInstanceMorph methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 17:40'!
instance
	^ pobject! !

!PInstanceMorph methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 17:58'!
instance: aPObject
	pobject := aPObject.
	self adjust! !

SystemWindow subclass: #PVisualizer
	instanceVariableNames: 'window list stepsPane steps selectedStep signalId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives-Visualization'!

!PVisualizer class methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 14:47'!
open
	^ self new open! !

!PVisualizer methodsFor: 'as yet unclassified' stamp: 'RL 12/16/2011 23:33'!
accept: text
	"ignore"! !

!PVisualizer methodsFor: 'steps' stamp: 'RL 12/29/2011 14:19'!
addStep: aStep
	steps addStep: aStep.
	self selectStep: steps size! !

!PVisualizer methodsFor: 'steps' stamp: 'RL 12/29/2011 16:09'!
connectSignal
	signalId := PObject onInstanceCreation: [ :instance | self instanceCreated: instance ]! !

!PVisualizer methodsFor: 'layout' stamp: 'RL 12/14/2011 14:47'!
createChildren
	| htop hbottom wleft |
	htop := 0.2.
	hbottom := 0.2.
	wleft := 0.3.
	window
		addMorph: self createUpperPane frame: (0@0 corner: 1@htop);
		addMorph: self createList frame: (0@htop corner: wleft@(1-hbottom));
		addMorph: self createPane frame: (wleft@htop corner: 1@(1-hbottom));
		addMorph: self createLowerPane frame: (0@(1-hbottom) corner: 1@1)! !

!PVisualizer methodsFor: 'layout' stamp: 'RL 12/16/2011 22:55'!
createList
	^ (list := PluggableListMorph
		on: self
		list: #steps
		selected: #selectedStep
		changeSelected: #selectStep:)
			color: Color white;
			yourself
		! !

!PVisualizer methodsFor: 'layout' stamp: 'RL 12/16/2011 23:31'!
createLowerPane
	^ PluggableTextMorphPlus
		on: self
		text: #name
		accept: #accept:! !

!PVisualizer methodsFor: 'layout' stamp: 'RL 12/29/2011 17:23'!
createPane
	^ stepsPane := (PStepsPane on: steps)
		color: Color white;
		yourself! !

!PVisualizer methodsFor: 'layout' stamp: 'RL 12/16/2011 23:36'!
createUpperPane
	| text |
	text := PluggableTextMorphPlus
		on: self
		text: #d
		accept: #accept:.
	text wantsFrameAdornments: false.
	text styler: (SHTextStylerST80 new view: text; yourself).
	text textMorph editor model: self.
	^ text! !

!PVisualizer methodsFor: 'layout' stamp: 'RL 12/14/2011 14:56'!
createWindow
	window := SystemWindow new.
	window
		model: self;
		setLabel: 'PVisualizer';
		setWindowColor: self defaultColor.
	self
		createChildren! !

!PVisualizer methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 17:00'!
d
	 ^ '(PerspectiveObject1 new @ TestChildLayer) isTestLayer'! !

!PVisualizer methodsFor: 'steps' stamp: 'RL 12/29/2011 16:09'!
disconnectSignal
	signalId ifNotNil: [
		PObject disconnect: signalId.
		signalId := nil
	]! !

!PVisualizer methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 13:14'!
doItContext
	^ nil! !

!PVisualizer methodsFor: 'as yet unclassified' stamp: 'RL 12/16/2011 23:43'!
doItReceiver
	^ self ! !

!PVisualizer methodsFor: 'as yet unclassified' stamp: 'RL 12/16/2011 23:04'!
finalize
	self disconnectSignal! !

!PVisualizer methodsFor: 'steps' stamp: 'RL 12/29/2011 14:46'!
found: aCompiledMethod for: aPiece
	self addStep: (PFoundStep on: aPiece with: aCompiledMethod)! !

!PVisualizer methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 14:27'!
initialize
	super initialize.
	steps := PStepList new.
	self createWindow.
	self connectSignal.! !

!PVisualizer methodsFor: 'steps' stamp: 'RL 12/29/2011 17:22'!
instanceCreated: instance
	self addStep: (PInstanceCreationStep on: instance).
	instance methodDispatcher methodLookup
		onLookingUp: [ :selector | self lookingUp: selector for: instance ];
		onSearching: [ :class | self searching: class for: instance ];
		onFound: [ :method |  self found: method for: instance ].
	stepsPane update! !

!PVisualizer methodsFor: 'steps' stamp: 'RL 12/29/2011 14:47'!
lookingUp: aSelector for: aPiece
	self addStep: (PLookUpStep on: aPiece with: aSelector)! !

!PVisualizer methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 14:48'!
open
	"window openInWorldExtent: 800@600"
	window openInWorld! !

!PVisualizer methodsFor: 'steps' stamp: 'RL 12/29/2011 14:47'!
searching: aClass for: aPiece
	self addStep: (PSearchingStep on: aPiece with: aClass)! !

!PVisualizer methodsFor: 'steps' stamp: 'RL 12/29/2011 17:28'!
selectStep: anIndex
	selectedStep := anIndex.
	list updateList.
	stepsPane selectStep: anIndex! !

!PVisualizer methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 13:13'!
selectedClass
	^ self class! !

!PVisualizer methodsFor: 'steps' stamp: 'RL 12/16/2011 22:54'!
selectedStep
	^ selectedStep ifNil: [0]! !

!PVisualizer methodsFor: 'steps' stamp: 'RL 12/29/2011 14:19'!
steps
	^ steps steps! !

!PVisualizer methodsFor: 'as yet unclassified' stamp: 'RL 12/16/2011 22:58'!
windowIsClosing
	self disconnectSignal! !

TestCase subclass: #TestPerspectives
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives-Tests'!

!TestPerspectives methodsFor: 'as yet unclassified' stamp: 'RL 12/8/2011 23:41'!
testDirectPerspectiveCall
	| object |
	object := PerspectiveObject1 new.
	self assert: [ object returnValue = 42 ].
	self assert: [ (object @ nil) returnValue = 42 ].
	self assert: [ (object @ TestLayer) returnValue = 23 ].! !

!TestPerspectives methodsFor: 'as yet unclassified' stamp: 'RL 12/8/2011 23:41'!
testDoesNotUnderstand
	| object |
	object := PerspectiveObject1 new.
	self should: [ object foo ] raise: MessageNotUnderstood.
	self should: [ (object @ nil) foo ] raise: MessageNotUnderstood.
	self should: [ (object @ TestLayer) foo ] raise: MessageNotUnderstood.! !

!TestPerspectives methodsFor: 'as yet unclassified' stamp: 'RL 12/8/2011 23:42'!
testHiddenMethod
	| object |
	object := PerspectiveObject1 new.
	object method1.
	(object @ TestLayer) method1.
	self should: [ (object @ TestChildLayer) method1 ] raise: MessageNotUnderstood.! !

!TestPerspectives methodsFor: 'as yet unclassified' stamp: 'RL 12/8/2011 23:41'!
testIdentityInvariant
	| object |
	object := PerspectiveObject1 new.
	self assert: [ (object @ TestLayer) = (object @ TestChildLayer) ].
	self assert: [ (object @ TestLayer) = object ].
	self assert: [ object = (object @ TestLayer) ].! !

!TestPerspectives methodsFor: 'as yet unclassified' stamp: 'RL 12/8/2011 23:41'!
testIndirectPerspectiveCall
	| object |
	object := PerspectiveObject1 new.
	self assert: [ object callReturnValue = 42 ].
	self assert: [ (object @ TestLayer) callReturnValue = 23 ].! !

!TestPerspectives methodsFor: 'as yet unclassified' stamp: 'RL 12/8/2011 23:41'!
testLayerSwitching
	| object  |
	object := PerspectiveObject1 new.
	self assert: [ (object @ TestChildLayer @ TestLayer) returnValue = 23 ].
	self assert: [ (object @ TestLayer @ TestChildLayer) returnValue = 15 ].! !

!TestPerspectives methodsFor: 'as yet unclassified' stamp: 'RL 12/8/2011 23:46'!
testParentLayer
	| object  |
	object := PerspectiveObject1 new.
	self assert: [ (object @ TestLayer) returnValue = 23 ].
	self assert: [ (object @ TestChildLayer) returnValue = 15 ].
	
	self assert: [ (object @ TestLayer) isTestLayer ].
	self assert: [ (object @ TestChildLayer) isTestLayer ].
	
	self assert: [ (object @ TestChildLayer) isTestChildLayer ].
	self should: [ (object @ TestLayer) isTestChildLayer ] raise: MessageNotUnderstood.
	! !

!TestPerspectives methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 16:52'!
testProceed
	| object  |
	object := PerspectiveObject1 new.
	self assert: [ (object @ TestLayer) someValue = 100 ].
	self assert: [ (object @ TestChildLayer) someValue = 200 ].
	
	self assert: [ ((object @ TestLayer) doSomethingWith: 5) = 10 ].
	self assert: [ ((object @ TestChildLayer) doSomethingWith: 5) = 20 ]! !

Object subclass: #PLayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives'!

PLayer class
	instanceVariableNames: 'parentLayer'!

PLayer class
	instanceVariableNames: 'parentLayer'!

PLayer subclass: #PDefaultLayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives'!

!PLayer class methodsFor: 'as yet unclassified' stamp: 'RL 12/7/2011 12:09'!
hasParentLayer
	^ parentLayer notNil! !

!PLayer class methodsFor: 'as yet unclassified' stamp: 'RL 12/8/2011 23:54'!
initialParentLayer
	"subclasses should override this and return the initial parent layer to be used upon class creation"
	^ nil! !

!PLayer class methodsFor: 'as yet unclassified' stamp: 'RL 12/7/2011 11:56'!
new
	self shouldNotImplement! !

!PLayer class methodsFor: 'as yet unclassified' stamp: 'RL 12/8/2011 23:54'!
parentLayer
	^ parentLayer ifNil: [ self initialParentLayer ]! !

!PLayer class methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 16:09'!
parentLayer: aLayer
	(aLayer inheritsFrom: PLayer)
		ifTrue: [ parentLayer := aLayer ]
		ifFalse: [ self error: 'parentLayer has to be a subclass of PerspectiveLayer' ]! !

PLayer subclass: #TestChildLayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives-Tests'!

!TestChildLayer methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 16:51'!
doSomethingWith: aNumber
	^ self proceedWith: 2*aNumber! !

!TestChildLayer methodsFor: 'as yet unclassified' stamp: 'RL 12/8/2011 23:54'!
initialParentLayer
	^ TestLayer! !

!TestChildLayer methodsFor: 'as yet unclassified' stamp: 'RL 12/8/2011 23:45'!
isTestChildLayer
	^ true! !

!TestChildLayer methodsFor: 'as yet unclassified' stamp: 'RL 12/8/2011 22:13'!
method1
	<pragma: #hide>! !

!TestChildLayer methodsFor: 'as yet unclassified' stamp: 'RL 12/4/2011 18:29'!
newMethod
	^ 2! !

!TestChildLayer methodsFor: 'as yet unclassified' stamp: 'RL 12/4/2011 18:25'!
returnValue
	^ 15! !

!TestChildLayer methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 12:55'!
someValue
	^ self proceed * 2! !

PLayer subclass: #TestLayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives-Tests'!

!TestLayer methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 16:51'!
doSomethingWith: aNumber
	^ 2 * aNumber! !

!TestLayer methodsFor: 'as yet unclassified' stamp: 'RL 12/8/2011 23:44'!
isTestLayer
	^ true! !

!TestLayer methodsFor: 'as yet unclassified' stamp: 'RL 12/4/2011 17:19'!
returnValue
	^ 23! !

!TestLayer methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 12:55'!
someValue
	^ 100! !

Object subclass: #PMethodDispatcher
	instanceVariableNames: 'receiver stack methodLookup'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives'!

!PMethodDispatcher class methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 15:44'!
for: receiver
	^ self new
		receiver: receiver;
		yourself! !

!PMethodDispatcher methodsFor: 'stack' stamp: 'RL 12/29/2011 16:45'!
currentPerspective
	^ stack isEmpty
		ifTrue: [ nil ]
		ifFalse: [ stack top value ]! !

!PMethodDispatcher methodsFor: 'stack' stamp: 'RL 12/29/2011 16:45'!
currentSelector
	^ stack isEmpty
		ifTrue: [ nil ]
		ifFalse: [ stack top key ]! !

!PMethodDispatcher methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 16:43'!
initialize
	super initialize.
	stack := Stack new! !

!PMethodDispatcher methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 15:44'!
lookupClass
	^ receiver class! !

!PMethodDispatcher methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 16:25'!
lookupSelector: aSelector
	^ self methodLookup
		perspective: self currentPerspective;
		lookupSelector: aSelector! !

!PMethodDispatcher methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 16:11'!
methodLookup
	^ methodLookup ifNil: [ methodLookup := PMethodLookup for: self lookupClass ]! !

!PMethodDispatcher methodsFor: 'dispatching' stamp: 'RL 12/29/2011 16:18'!
perform: aSelector withArguments: arguments
	^ self
		perform: aSelector
		withArguments: arguments
		in: self currentPerspective! !

!PMethodDispatcher methodsFor: 'dispatching' stamp: 'RL 12/29/2011 16:44'!
perform: aSelector withArguments: arguments in: aPerspective
	| method result |
	self push: aSelector in: aPerspective.
	method := (self lookupSelector: aSelector)
		ifNil: [ ^ self sendDoesNotUnderstand: aSelector withArguments: arguments ].
	result := receiver withArgs: arguments executeMethod: method.
	self pop.
	^ result! !

!PMethodDispatcher methodsFor: 'stack' stamp: 'RL 12/29/2011 16:44'!
pop
	stack pop! !

!PMethodDispatcher methodsFor: 'dispatching' stamp: 'RL 12/29/2011 16:49'!
proceed
	^ self proceedWithArguments: #()
	! !

!PMethodDispatcher methodsFor: 'dispatching' stamp: 'RL 12/29/2011 16:48'!
proceedWithArguments: arguments
	| perspective |
	perspective := (self currentPerspective ifNil: [ ^ self error: 'Cannot proceed' ])
		parentLayer ifNil: [ ^ self error: 'Cannot proceed' ].
	^ self
		perform: self currentSelector
		withArguments: arguments
		in: perspective
	
	! !

!PMethodDispatcher methodsFor: 'stack' stamp: 'RL 12/29/2011 16:44'!
push: aSelector in: aPerspective
	stack push: aSelector -> aPerspective! !

!PMethodDispatcher methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 15:44'!
receiver
	^ receiver! !

!PMethodDispatcher methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 15:44'!
receiver: anObject
	receiver := anObject! !

!PMethodDispatcher methodsFor: 'dispatching' stamp: 'RL 12/29/2011 15:45'!
sendDoesNotUnderstand: selector withArguments: arguments
	^ receiver doesNotUnderstand: 
		((Message selector: selector arguments: arguments)
			lookupClass: self lookupClass;
			yourself)! !

!PMethodDispatcher methodsFor: 'dispatching' stamp: 'RL 12/29/2011 16:18'!
sendMessage: aMessage
	^ self
		perform: aMessage selector
		withArguments: aMessage arguments
		in: self currentPerspective! !

!PMethodDispatcher methodsFor: 'dispatching' stamp: 'RL 12/29/2011 15:46'!
sendMessage: aMessage in: aPerspective
	^ self
		perform: aMessage selector
		withArguments: aMessage arguments
		in: aPerspective! !

Object subclass: #PMethodLookup
	instanceVariableNames: 'lookupClass perspective signalHandler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives'!

!PMethodLookup class methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 15:50'!
for: aClass
	^ self new
		lookupClass: aClass;
		yourself! !

!PMethodLookup methodsFor: 'signal-emitting' stamp: 'RL 12/16/2011 20:08'!
found: aCompiledMethod
	^ signalHandler emit: #found with: aCompiledMethod! !

!PMethodLookup methodsFor: 'signal-emitting' stamp: 'RL 12/29/2011 15:51'!
hiddenMethod
	signalHandler emit: #hiddenMethod! !

!PMethodLookup methodsFor: 'lookup' stamp: 'RL 12/16/2011 20:25'!
inClassHierarchyLookupSelector: aSelector
	| class |
	class := lookupClass.
	[ class isNil ] whileFalse: [
		self searching: class.
		(class includesSelector: aSelector) ifTrue: [ ^ (class compiledMethodAt: aSelector) method ].
		class := class superclass
	].
	^ nil! !

!PMethodLookup methodsFor: 'lookup' stamp: 'RL 12/29/2011 15:52'!
inPerspectiveHierarchyLookupSelector: aSelector
	| p |
	p := perspective.
	[ p isNil ] whileFalse: [
		self searching: p.
		(p includesSelector: aSelector) ifTrue: [ ^ p compiledMethodAt: aSelector ].
		p := p parentLayer
	].
	^ nil! !

!PMethodLookup methodsFor: 'as yet unclassified' stamp: 'RL 12/16/2011 20:02'!
initialize
	super initialize.
	signalHandler := PSignalHandler new! !

!PMethodLookup methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 15:52'!
isHidden: aMethod
	^ aMethod
		ifNil: [ false ]
		ifNotNil: [ :method |
			method pragmas
				anySatisfy: [ :pragma | pragma arguments
					anySatisfy: [ :arg | arg = #hide ] ] ]! !

!PMethodLookup methodsFor: 'signal-emitting' stamp: 'RL 12/29/2011 13:13'!
lookingUp: aSelector
	^ signalHandler emit: #lookingUp with: aSelector! !

!PMethodLookup methodsFor: 'as yet unclassified' stamp: 'RL 12/6/2011 00:32'!
lookupClass
	^ lookupClass! !

!PMethodLookup methodsFor: 'as yet unclassified' stamp: 'RL 12/6/2011 00:32'!
lookupClass: aClass
	lookupClass := aClass! !

!PMethodLookup methodsFor: 'lookup' stamp: 'RL 12/16/2011 20:13'!
lookupSelector: aSelector
	| method |
	self lookingUp: aSelector.
	method := self privateLookupSelector: aSelector.
	self found: method.
	^ method! !

!PMethodLookup methodsFor: 'signals' stamp: 'RL 12/16/2011 20:09'!
onFound: aBlock
	^ signalHandler connect: #found to: aBlock! !

!PMethodLookup methodsFor: 'signals' stamp: 'RL 12/29/2011 15:51'!
onHiddenMethod: aBlock
	^ signalHandler connect: #hiddenMethod to: aBlock! !

!PMethodLookup methodsFor: 'signals' stamp: 'RL 12/16/2011 20:10'!
onLookingUp: aBlock
	^ signalHandler connect: #lookingUp to: aBlock! !

!PMethodLookup methodsFor: 'signals' stamp: 'RL 12/16/2011 20:09'!
onSearching: aBlock
	^ signalHandler connect: #searching to: aBlock! !

!PMethodLookup methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 15:52'!
perspective
	^ perspective! !

!PMethodLookup methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 15:52'!
perspective: aPerspective
	perspective := aPerspective! !

!PMethodLookup methodsFor: 'lookup' stamp: 'RL 12/29/2011 15:52'!
privateLookupSelector: aSelector
	| method |
	method := self inPerspectiveHierarchyLookupSelector: aSelector.
	(self isHidden: method) ifTrue: [
		self hiddenMethod.
		^ nil ].
	method ifNil: [ method := self inClassHierarchyLookupSelector: aSelector ].
	^ method! !

!PMethodLookup methodsFor: 'signal-emitting' stamp: 'RL 12/29/2011 13:10'!
searching: aPerspectiveOrClass
	^ signalHandler emit: #searching with: aPerspectiveOrClass! !

!PMethodLookup methodsFor: 'signals' stamp: 'RL 12/16/2011 20:03'!
signalHandler
	^ signalHandler! !

Object subclass: #PMethodWrapper
	instanceVariableNames: 'method'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives'!

!PMethodWrapper class methodsFor: 'as yet unclassified' stamp: 'RL 12/6/2011 00:04'!
for: aCompiledMethod
	^ self new
		method: aCompiledMethod;
		yourself! !

!PMethodWrapper methodsFor: 'as yet unclassified' stamp: 'RL 12/4/2011 15:12'!
doesNotUnderstand: aMessage
	^ aMessage sendTo: method! !

!PMethodWrapper methodsFor: 'as yet unclassified' stamp: 'RL 12/4/2011 15:07'!
method
	^ method! !

!PMethodWrapper methodsFor: 'as yet unclassified' stamp: 'RL 12/4/2011 15:07'!
method: aCompiledMethod
	method := aCompiledMethod! !

!PMethodWrapper methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 15:47'!
run: selector with: arguments in: receiver
	^ receiver methodDispatcher
		perform: selector
		withArguments: arguments! !

!PMethodWrapper methodsFor: 'as yet unclassified' stamp: 'RL 12/4/2011 17:34'!
selector
	^ method selector! !

!PMethodWrapper methodsFor: 'as yet unclassified' stamp: 'RL 12/4/2011 18:10'!
selector: aSelector
	"ignore"
! !

Object subclass: #PObject
	instanceVariableNames: 'methodDispatcher'
	classVariableNames: 'InstanceCreatedSignal'
	poolDictionaries: ''
	category: 'Perspectives'!

!PObject class methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 16:09'!
basicAddSelector: selector withMethod: compiledMethod
	(self ~= PObject and: [ PObject includesSelector: selector ])
		ifTrue: [ ^ self error: 'You mustn''t override this method' ].
	^ super
		basicAddSelector: selector
		withMethod: (self = PObject
			ifTrue: [ compiledMethod ]
			ifFalse: [ self wrapMethod: compiledMethod ])! !

!PObject class methodsFor: 'instance creation' stamp: 'RL 12/29/2011 15:58'!
basicNew
	| instance |
	instance := super basicNew.
	self instanceCreated: instance.
	^ instance! !

!PObject class methodsFor: 'signals' stamp: 'RL 12/29/2011 15:57'!
disconnect: anId
	self instanceCreatedSignal disconnect: anId! !

!PObject class methodsFor: 'signals' stamp: 'RL 12/29/2011 16:07'!
instanceCreated: anInstance
	self instanceCreatedSignal emitWith: anInstance! !

!PObject class methodsFor: 'signals' stamp: 'RL 12/29/2011 16:06'!
instanceCreatedSignal
	^ InstanceCreatedSignal ifNil: [ InstanceCreatedSignal := PSignal new ]! !

!PObject class methodsFor: 'signals' stamp: 'RL 12/29/2011 16:13'!
onInstanceCreation: aBlock
	^ self instanceCreatedSignal connect: aBlock! !

!PObject class methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 16:10'!
wrapMethod: aCompiledMethod
	^ PMethodWrapper for: aCompiledMethod! !

!PObject methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 16:15'!
= anObject
	^ anObject class = Piece
		ifTrue: [ anObject = self ]
		ifFalse: [ self == anObject ]! !

!PObject methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 16:15'!
@ aPLayer
	^ Piece for: self in: aPLayer! !

!PObject methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 16:10'!
methodDispatcher
	^ methodDispatcher ifNil: [ methodDispatcher := PMethodDispatcher for: self ]! !

!PObject methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 12:56'!
proceed
	^ methodDispatcher proceed! !

!PObject methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 16:53'!
proceedWith: arg1
	^ self proceedWithArguments: (Array with: arg1)! !

!PObject methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 16:53'!
proceedWith: arg1 with: arg2
	^ self proceedWithArguments: (Array with: arg1 with: arg2)! !

!PObject methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 16:53'!
proceedWith: arg1 with: arg2 with: arg3
	^ self proceedWithArguments: (Array with: arg1 with: arg2 with: arg3)! !

!PObject methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 16:54'!
proceedWithArguments: arguments
	^ methodDispatcher proceedWithArguments: arguments! !

PObject subclass: #PerspectiveObject1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives-Tests'!

!PerspectiveObject1 methodsFor: 'as yet unclassified' stamp: 'RL 12/4/2011 23:55'!
callReturnValue
	^ self returnValue! !

!PerspectiveObject1 methodsFor: 'as yet unclassified' stamp: 'RL 12/8/2011 22:13'!
method1
	"not hidden"! !

!PerspectiveObject1 methodsFor: 'as yet unclassified' stamp: 'RL 12/5/2011 02:31'!
returnValue
	^ 42! !

Object subclass: #PSignal
	instanceVariableNames: 'callbacks nextId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives'!

!PSignal methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 13:45'!
connect: aBlock
	| id |
	id := nextId.
	callbacks at: id put: aBlock.
	nextId := nextId + 1.
	^ id
	! !

!PSignal methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 13:45'!
disconnect: anId
	^ callbacks removeKey: anId ifAbsent: []! !

!PSignal methodsFor: 'as yet unclassified' stamp: 'RL 12/16/2011 20:40'!
disconnectAll
	^ callbacks removeAll! !

!PSignal methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 13:34'!
emit
	self emitWithArguments: #()! !

!PSignal methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 14:36'!
emitWith: arg1
	self emitWithArguments: (Array with: arg1)! !

!PSignal methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 14:36'!
emitWith: arg1 with: arg2
	self emitWithArguments: (Array with: arg1 with: arg2)! !

!PSignal methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 14:36'!
emitWith: arg1 with: arg2 with: arg3
	self emitWithArguments: (Array with: arg1 with: arg2 with: arg3)! !

!PSignal methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 13:57'!
emitWithArguments: arguments
	callbacks do: [ :callback | 
		callback valueWithArguments: (self resizeArguments: arguments toFit: callback argumentCount)
	]! !

!PSignal methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 14:28'!
initialize
	super initialize.
	callbacks := Dictionary new.
	nextId := 0.! !

!PSignal methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 14:40'!
resizeArguments: arguments toFit: aSize
	| newArgs |
	newArgs := Array new: aSize.
	1 to: aSize do: [ :i |
		newArgs at: i put: (arguments at: i ifAbsent: [ nil ])
	].
	^ newArgs! !

Object subclass: #PSignalHandler
	instanceVariableNames: 'signals'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives'!

!PSignalHandler methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 13:46'!
connect: signalName to: aBlock
	^ ( signals at: signalName ifAbsentPut: [ PSignal new ])
		connect: aBlock! !

!PSignalHandler methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 13:46'!
disconnect: signalName from: anId
	(signals at: signalName ifAbsent: [ ^ self ]) disconnect: anId! !

!PSignalHandler methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 13:47'!
emit: signalName
	 (signals at: signalName ifAbsentPut: [ ^ self ]) emit! !

!PSignalHandler methodsFor: 'as yet unclassified' stamp: 'RL 12/16/2011 20:05'!
emit: signalName with: arg1
	 (signals at: signalName ifAbsentPut: [ ^ self ])
		emitWithArguments: (Array with: arg1)! !

!PSignalHandler methodsFor: 'as yet unclassified' stamp: 'RL 12/16/2011 20:05'!
emit: signalName with: arg1 with: arg2
	 (signals at: signalName ifAbsentPut: [ ^ self ])
		emitWithArguments: (Array with: arg1 with: arg2)! !

!PSignalHandler methodsFor: 'as yet unclassified' stamp: 'RL 12/16/2011 20:05'!
emit: signalName with: arg1 with: arg2 with: arg3
	 (signals at: signalName ifAbsentPut: [ ^ self ])
		emitWithArguments: (Array with: arg1 with: arg2 with: arg3)! !

!PSignalHandler methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 13:47'!
emit: signalName withArguments: arguments
	 (signals at: signalName ifAbsentPut: [ ^ self ]) emitWithArguments: arguments! !

!PSignalHandler methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 13:36'!
initialize
	super initialize.
	signals := Dictionary new! !

Object subclass: #PStep
	instanceVariableNames: 'instance'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives-Visualization'!

PStep subclass: #PFoundStep
	instanceVariableNames: 'method'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives-Visualization'!

!PFoundStep class methodsFor: 'instance creation' stamp: 'RL 12/29/2011 18:26'!
on: aPObject with: aMethod
	^ self new
		instance: aPObject;
		method: aMethod;
		yourself! !

!PFoundStep methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 14:45'!
method
	^ method! !

!PFoundStep methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 14:45'!
method: aMethod
	method := aMethod! !

!PFoundStep methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 14:52'!
printOn: aStream
	aStream
		nextPutAll: 'found method in: ';
		nextPutAll: method methodClass name
	! !

PStep subclass: #PInstanceCreationStep
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives-Visualization'!

!PInstanceCreationStep class methodsFor: 'instance creation' stamp: 'RL 12/29/2011 18:25'!
on: aPObject
	^ self new
		instance: aPObject;
		yourself! !

!PInstanceCreationStep methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 17:20'!
isInstanceCreation
	^ true! !

!PInstanceCreationStep methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 18:28'!
printOn: aStream
	aStream nextPutAll: 'create: '.
	instance printOn: aStream! !

PStep subclass: #PLookUpStep
	instanceVariableNames: 'selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives-Visualization'!

!PLookUpStep class methodsFor: 'instance creation' stamp: 'RL 12/29/2011 18:26'!
on: aPObject with: selector
	^ self new
		instance: aPObject;
		selector: selector;
		yourself! !

!PLookUpStep methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 14:48'!
printOn: aStream
	aStream
		nextPutAll: 'looking up: #';
		nextPutAll: selector
	! !

!PLookUpStep methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 14:42'!
selector
	^ selector! !

!PLookUpStep methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 14:42'!
selector: aSelector
	selector := aSelector! !

PStep subclass: #PSearchingStep
	instanceVariableNames: 'classOrPerspective'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives-Visualization'!

!PSearchingStep class methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 18:26'!
on: aPObject with: aClassOrPerspective
	^ self new
		instance: aPObject;
		classOrPerspective: aClassOrPerspective;
		yourself! !

!PSearchingStep methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 14:44'!
classOrPerspective
	^ classOrPerspective! !

!PSearchingStep methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 14:44'!
classOrPerspective: aClassOrPerspective
	classOrPerspective := aClassOrPerspective! !

!PSearchingStep methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 14:50'!
printOn: aStream
	aStream
		nextPutAll: 'searching in: ';
		nextPutAll: classOrPerspective name
	! !

!PStep methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 18:25'!
instance
	^ instance! !

!PStep methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 18:25'!
instance: aPObject
	instance := aPObject! !

!PStep methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 17:20'!
isInstanceCreation
	^ false! !

Object subclass: #PStepList
	instanceVariableNames: 'steps'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives-Visualization'!

!PStepList methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 14:17'!
addStep: aPLookupStep
	steps add: aPLookupStep! !

!PStepList methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 14:17'!
initialize
	super initialize.
	steps := OrderedCollection new! !

!PStepList methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 18:00'!
instances
	^ steps select: [ :step | step isInstanceCreation ] thenCollect: [ :step | step instance ]! !

!PStepList methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 14:19'!
size
	^ steps size! !

!PStepList methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 14:18'!
steps
	^ steps! !

Object subclass: #PieceImplementation
	instanceVariableNames: 'object perspective'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives'!

PieceImplementation class
	instanceVariableNames: 'instanceCreatedSignal signalsEnabled'!

PieceImplementation class
	instanceVariableNames: 'instanceCreatedSignal signalsEnabled'!

!PieceImplementation class methodsFor: 'instance creation' stamp: 'RL 12/14/2011 15:14'!
for: anObject in: aPerspective
	^ self new
		initializeOnObject: anObject andPerspective: aPerspective! !

!PieceImplementation methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 15:43'!
handleMessage: aMessage
	^ object methodDispatcher
		sendMessage: aMessage
		in: perspective! !

!PieceImplementation methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 15:42'!
initializeOnObject: anObject andPerspective: aPerspective
	object := anObject.
	perspective := aPerspective.
	^ self! !

!PieceImplementation methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 15:11'!
object
	^ object! !

!PieceImplementation methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 15:42'!
perspective
	^ perspective! !

ScrollPane subclass: #PStepsPane
	instanceVariableNames: 'steps'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives-Visualization'!

!PStepsPane class methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 14:27'!
on: aPStepList
	^ self new
		steps: aPStepList;
		yourself! !

!PStepsPane methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 14:23'!
selectStep: anIndex! !

!PStepsPane methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 14:22'!
steps: stepList
	steps := stepList! !

!PStepsPane methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 17:54'!
update
	| w offset |
	self scroller removeAllMorphs.
	offset := 5.
	w := offset.
	steps instances do: [ :instance | | m |
		m := PInstanceMorph for: instance.
		m position: w@offset.
		self scroller addMorph: m.
		w := w + m width + offset.
	].
	self extent: w@200.
	self hScrollBarValue: w! !

ProtoObject subclass: #Piece
	instanceVariableNames: 'implementation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives'!

Piece class
	instanceVariableNames: 'instanceCreatedSignal'!

Piece class
	instanceVariableNames: 'instanceCreatedSignal'!

!Piece class methodsFor: 'instance creation' stamp: 'RL 12/29/2011 15:57'!
for: anObject in: aPerspective
	^ super new
		pieceImplementation: (PieceImplementation for: anObject in: aPerspective)! !

!Piece class methodsFor: 'instance creation' stamp: 'RL 12/14/2011 14:28'!
new
	self shouldNotImplement! !

!Piece methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 15:44'!
asString
	^ self printString! !

!Piece methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 15:44'!
asStringOrText
	^ self printString! !

!Piece methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 15:16'!
doesNotUnderstand: aMessage
	^ implementation handleMessage: aMessage! !

!Piece methodsFor: 'as yet unclassified' stamp: 'RL 12/4/2011 17:32'!
inspect
	ToolSet inspect: self! !

!Piece methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 14:12'!
pieceImplementation
	^ implementation! !

!Piece methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 14:12'!
pieceImplementation: aPieceImplementation
	implementation := aPieceImplementation! !

!Piece methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 14:31'!
printOn: aStream
	aStream
		nextPutAll: implementation object asString;
		nextPutAll: '@';
		nextPutAll: implementation perspective asString! !

!Piece methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 14:31'!
printString
	^ String streamContents: [ :stream | self printOn: stream ].! !

!Piece methodsFor: 'as yet unclassified' stamp: 'RL 12/8/2011 23:17'!
printStringLimitedTo: limit
	"Answer a String whose characters are a description of the receiver.
	If you want to print without a character limit, use fullPrintString."
	| limitedString |
	limitedString := String streamContents: [:s | self printOn: s] limitedTo: limit.
	limitedString size < limit ifTrue: [^ limitedString].
	^ limitedString , '...etc...'! !
